
module Eval where

type VarName = String

data Expr = Lit Double
          | Var VarName
          | Add Expr Expr
          | Sub Expr Expr
          | Mul Expr Expr
          | Div Expr Expr
          deriving (Show)

type Env = [(VarName,Double)]

type Error = String

type ResultOrError a = Either Error a
newtype Eval a = Eval { runEval :: Env -> ResultOrError a }

-- Implementieren Sie die Funktor-Instanz von Eval
instance Functor Eval where
    fmap f e = undefined

-- Seit einer Weile ist eine Instanziierung von Applicative eine Voraussetzung, um Daten als Monade
-- instanziieren zu können
-- Sie können diese Instanz aber ignorieren
instance Applicative Eval where
    pure a = Eval $ const $ Right a
    ef <*> ea = Eval $ \env -> do f <- runEval ef env
                                  a <- runEval ea env
                                  return $ f a


-- Implementieren Sie die Monaden-Instance für Eval
instance Monad Eval where
    return a = undefined
    e >>= f =  undefined


-- throw an Error inside Eval monad
throwError :: Error -> Eval a
throwError = Eval . const . Left

-- save division, throws error "Division by 0!" when denominator is 0
saveDiv :: Double -> Double -> Eval Double
saveDiv _ 0 = throwError "Division by 0!"
saveDiv x y = return $ x / y

-- perform lookup ov variable in evironment
envLookup :: VarName -> Env -> ResultOrError Double
envLookup v [] = Left "Unbound variable!"
envLookup v ((v',val):es)
    | v == v'   = return val
    | otherwise = envLookup v es


-- Implementieren Sie die Funktion eval, die einen Ausdruck in eine Evaluation Eval übersetzt
-- der Aufruf von
-- runEval (eval expr) env
-- mit einem Ausdruck expr und einer Umgebung env sollte expr in env auswerten
eval :: Expr -> Eval Double
eval = undefined

-- Man kann Eval auch zum Pretty-Printing verwenden.
-- in diesem Fall liefert (runEval (pretty expr) env dann einen String, der ausgegeben werden kann
pretty :: Expr -> Eval String
pretty = undefined
